//
//  ViewController.swift
//  Vault
//
//  Created by Jake Marsh on 5/25/15.
//  Copyright (c) 2015 Magnus. All rights reserved.
//

import UIKit

let GapSize: CGFloat = 5.0

class ViewController: UIViewController {
    var open: Bool = false {
        didSet { transition() }
    }

    @IBOutlet weak var leftDoorView: UIImageView!
    @IBOutlet weak var rightDoorView: UIImageView!
    @IBOutlet weak var leftDoorHorizontalConstraint: NSLayoutConstraint!
    @IBOutlet weak var rightDoorHorizontalConstraint: NSLayoutConstraint!

    func transition() {
        // force a layout before animating
        self.view.layoutIfNeeded()

        UIView.animateWithDuration(0.4) {
            // change constraints here
            // inside the animation block

            self.updateConstraintsForDoors()

            // force a layout inside the animation block
            self.view.layoutIfNeeded()
        }
    }

    func updateConstraintsForDoors() {
        leftDoorHorizontalConstraint.constant = open ? -16 : (-leftDoorView.bounds.size.width + GapSize - 1)
        rightDoorHorizontalConstraint.constant = open ? -16 : (-rightDoorView.bounds.size.width + GapSize)
    }

    override func viewDidLoad() {
        super.viewDidLoad()

        let gr = UITapGestureRecognizer(target: self, action: "toggleOpen")
        gr.numberOfTapsRequired = 1
        view.addGestureRecognizer(gr)
    }

    func toggleOpen() {
        open = !open
    }
}

